  member
  map
  end

  include('mysqlbr.inc'), once

MySQLBrowseCB     class, implements(sqlcallbackinterface), type
MySQLListControl  long
                  end


MySQLBrowse.Kill  procedure
  code
  if not self.CBI &= null
    dispose(self.CBI)
  end
  parent.kill()

MySQLBrowse.TakeEvent            PROCEDURE!,VIRTUAL
  code
  parent.TakeEvent()
  if event() = event:sized
    self.setcallbackon()
    self.myreset()
    self.resetsort(1)
    self.setcallbackoff()
  end

MySQLBrowse.MyReset   procedure
  code
  !self.resetfrombuffer()
  get(self.bq, choice(self.mysqllistcontrol))
  flush(self.view)
  set(self.view, self.posit)
  next(self.view)
!  if error()
!    stop(error())
!  end


MySQLBrowse.SetCallbackOn   procedure
  code
  if self.CallbackStatus = 0
    sqlcallback(self.primaryfile, self.CBI.sqlcallbackinterface)
  end
  self.CallBackStatus += 1


MySQLBrowse.SetCallbackOff  procedure
  code
  self.CallBackStatus -= 1
  if self.CallbackStatus =0
    sqlcallback(self.primaryfile, self.CBI.sqlcallbackinterface, 1)
  end

    

MySQLBrowse.PrimeRecord                     PROCEDURE(BYTE SuppressClear = 0)!,BYTE,PROC,VIRTUAL
rv  byte
  code
  self.SetCallbackOn()
  rv = parent.PrimeRecord(SuppressClear)
  self.SetCallbackOff()
  return rv



MySQLBrowse.ResetQueue           PROCEDURE(BYTE ResetMode)!,VIRTUAL
  code
  self.SetCallbackOn()
  parent.ResetQueue(ResetMode)
  self.SetCallbackOff()



MySQLBrowse.ResetFromFile        PROCEDURE!,VIRTUAL
  code
  self.SetCallbackOn()
  !self.myreset()
  parent.ResetFromFile()
  self.SetCallbackOff()


MySQLBrowse.ResetSort            PROCEDURE(BYTE Force)!,BYTE,VIRTUAL,PROC
rv  byte
  code
  self.SetCallbackOn()
  !self.myreset()
  rv = parent.ResetSort(force)
  self.SetCallbackOff()
  return rv


MySQLBrowse.ScrollEnd            PROCEDURE(SIGNED Event)!,VIRTUAL,PROTECTED
  code
  setcursor(cursor:wait)
  self.SetCallbackOn()
  !self.myreset()
  parent.scrollend(event)
  self.SetCallbackOff()
  setcursor()

MySQLBrowse.ScrollOne            PROCEDURE(SIGNED Event)!,VIRTUAL,PROTECTED
flag  long
  code
  if (event() = event:scrolldown and choice(self.MySQLListControl) = records(self.bq)) |
       or (event() = event:scrollup and choice(self.MySQLListControl) = 1)
    flag = 1
  end
  if flag
    setcursor(cursor:wait)
    self.SetCallbackOn()
    self.MyReset()
  end
  parent.scrollone(event)
  if flag
    self.SetCallbackOff()
    setcursor()
  end

MySQLBrowse.ScrollPage           PROCEDURE(SIGNED Event)!,VIRTUAL,PROTECTED
  code
  setcursor(cursor:wait)
  self.SetCallbackOn()
  self.MyReset()
  parent.scrollpage(event)
  self.SetCallbackOff()
  setcursor()

MySQLBrowse.Init                 PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)   !,EXTENDS
  code
  parent.Init(listbox, posit, v, q, rm, wm)
  self.MySQLListControl = ListBox
  self.CBI &= new MySQLBrowseCB
  self.CBI.MySQLListControl = ListBox
  self.posit &= Posit
  self.primaryfile &= rm.me.file
  self.bq &= q


MySQLBrowseCB.SQLCallbackInterface.ExecutingCode PROCEDURE(CONST *CSTRING inStr, *BYTE Err, *CSTRING ErrCode, *CSTRING ErrMsg)
  CODE
  if self.MySQLListControl = 0
    stop('List control property of MySQLCallbackInterface has not been set!')
    return instr
  end
  if upper(sub(inStr,1,7)) = 'SELECT '
    return instr & ' LIMIT ' & self.MySQLListControl{prop:items} + 1
  else
    return instr
  end

