#TEMPLATE(MySQLBr,'MySQL Page Load Browse'),FAMILY('CW20')
#!
#! Version 1.0
#!
#!
#!
#!
#EXTENSION(MySQLBrowseSupport,'Global MySQL page load support'), APPLICATION
#PROMPT('Enable MySQL Page Loaded Browse Support', CHECK), %MySQLPageLoadEnabled, AT(10,10)
#!
#!
#EXTENSION(MySQLBrowse,'MySQL Page Load Browse Extension'), REQ(BrowseBox(Clarion))
#RESTRICT
#IF(%MySQLPageLoadEnabled)
  #ACCEPT
#ELSE
  #REJECT
#ENDIF
#ENDRESTRICT
#DISPLAY('Be sure to use the global extension ''MySQLBrowseSupport''')
#DISPLAY('and enable it for this to work!')
#ATSTART
#ENDAT
#AT(%ModuleDataSection)
#IF(%MySQLPageLoadEnabled)
      INCLUDE('FILECB.INC'), ONCE
#ENDIF

#ENDAT
#AT(%DataSectionBeforeWindow)
#IF(%MySQLPageLoadEnabled)

MySQLcb:%ActiveTemplateParentInstance class, implements(sqlcallbackinterface)
wHandle         long
Flag            long
File            &File
SetCallbackOn   procedure()
SetCallbackOff  procedure
Reset           procedure()
                end

#ENDIF
#ENDAT
#AT(%AfterWindowOpening)
#IF(%MySQLPageLoadEnabled)

  MySQLcb:%ActiveTemplateParentInstance.wHandle = 0{prop:handle}
  MySQLcb:%ActiveTemplateParentInstance.File &= %Primary
  MySQLcb:%ActiveTemplateParentInstance.SetCallbackOn()

#ENDIF
#ENDAT
#AT(%BeforeWindowClosing)
#IF(%MySQLPageLoadEnabled)

  MySQLcb:%ActiveTemplateParentInstance.SetCallbackOff()

#ENDIF
#ENDAT
#AT(%AcceptLoopBeforeEventHandling)
#IF(%MySQLPageLoadEnabled)

  if event() = event:sized
    post(event:gainfocus)
  end

#ENDIF
#ENDAT

#AT(%ControlEventHandling,%ListControl,'ScrollUp'), PRIORITY(1)
#IF(%MySQLPageLoadEnabled)
  if choice(%Control) = 1
    MySQLcb:%ActiveTemplateParentInstance.Reset()
  end
#ENDIF
#ENDAT
#AT(%ControlEventHandling,%ListControl,'ScrollDown'), PRIORITY(1)
#IF(%MySQLPageLoadEnabled)
  if choice(%Control) = records(%ListQueue)
    MySQLcb:%ActiveTemplateParentInstance.Reset()
  end
#ENDIF
#ENDAT
#AT(%ControlEventHandling,%ListControl,'PageDown'), PRIORITY(1)
#IF(%MySQLPageLoadEnabled)
  MySQLcb:%ActiveTemplateParentInstance.Reset()
#ENDIF
#ENDAT
#AT(%ControlEventHandling,%ListControl,'PageUp'), PRIORITY(1)
#IF(%MySQLPageLoadEnabled)
  MySQLcb:%ActiveTemplateParentInstance.Reset()
#ENDIF
#ENDAT
#AT(%ControlEventHandling,%ListControl,'ScrollDrag'), PRIORITY(1)
#IF(%MySQLPageLoadEnabled)
#!  MySQLcb:%ActiveTemplateParentInstance.Reset()
#ENDIF
#ENDAT
#AT(%LocalProcedures)
#IF(%MySQLPageLoadEnabled)
MySQLcb:%ActiveTemplateParentInstance.sqlcallbackinterface.ExecutingCode  PROCEDURE(CONST *CSTRING inStr, *BYTE Err, *CSTRING ErrCode, *CSTRING ErrMsg)
  code
  if upper(sub(InStr,1,7)) = 'SELECT ' and self.wHandle = 0{prop:handle}
    return instr & ' LIMIT ' & %ListControl{prop:items} + 1
  else
    return instr
  end

MySQLcb:%ActiveTemplateParentInstance.SetCallbackOn procedure()
  code
  self.Flag += 1
  if self.Flag = 1
    SQLCallback(self.File, self.SQLCallbackInterface)
  end

MySQLcb:%ActiveTemplateParentInstance.SetCallbackOff  procedure()
  code
  self.Flag -= 1
  if self.Flag = 0
    SQLCallback(self.File, self.SQLCallbackInterface, 1)
  end

MySQLcb:%ActiveTemplateParentInstance.Reset    procedure()
  code
  flush(%ListView)
  get(%ListQueue, choice(%Control))
  set(%ListView, %ListQueue.Brw%ActiveTemplateParentInstance::position)
  next(%ListView)

#ENDIF
#ENDAT


