
!ABCIncludeFile

! --- Version 1.6


!    To use this:
!
!    Put mysqlbr.inc and mysqlbr.clw in Clarion's LIBSRC directory.
!
!    If Clarion is open at the time, click the "Refresh Application Builder Classes Information" in global settings.
!
!    For your browses (on the Action tab), select the MySQLBrowse as the class for your browses.
!
!    Alternatively, you can select the default browse class as MySQLBrowse in your global settings
!
!    Please report all problems:  twtools@yahoo.com

! --- fixed for version 1.6
!       The Reset method displayed an error (stop()) when no records were returned.  That error message should not have been there
!       and has been removed

! --- fixed for version 1.5
!       string slicing in the callback method changed to SUB() to avoid some rare out of bounds errors

! --- fixed for version 1.4
!       setcursor(cursor:wait) supplied for scrolling that had not been turning it on

! --- fixed for version 1.3
!       There were some *.exp issues when using the class in a multi-app (dll) system.  I believe
!       those issues have been fixed now

! --- fixed for version 1.2
!       Handles window resizing (queue is refilled)
!       Supports non-unique key with "additional sort fields" to make "orderby" unique
!       Number of records retrieved on each SELECT reduced by about half

! --- fixed for version 1.1
!       Embeds were not showing correctly.  The parent class in the declaration should be case sensitive apparently,
!       for the ABC class reader to work right.


  include('abbrowse.inc'), once

MySQLBrowse CLASS(BrowseClass),TYPE,MODULE('MYSQLBR.CLW'),LINK('MYSQLBR.CLW',_ABCLinkMode_),DLL(_ABCDllMode_)
CBI                  &MySQLBrowseCB
MySQLListControl     long
CallBackStatus       long
PrimaryFile          &file
BQ                   &queue
posit                &string
ScrollEnd            PROCEDURE(SIGNED Event),VIRTUAL,PROTECTED
ScrollOne            PROCEDURE(SIGNED Event),VIRTUAL,PROTECTED
ScrollPage           PROCEDURE(SIGNED Event),VIRTUAL,PROTECTED
Init                 PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)   !,EXTENDS
Kill                 PROCEDURE,VIRTUAL
ResetFromFile        PROCEDURE,VIRTUAL
ResetSort            PROCEDURE(BYTE Force),BYTE,VIRTUAL,PROC
ResetQueue           PROCEDURE(BYTE ResetMode),VIRTUAL
PrimeRecord          PROCEDURE(BYTE SuppressClear = 0),BYTE,PROC,VIRTUAL
SetCallbackOn        procedure
SetCallBackOff       procedure
MyReset              procedure
TakeEvent            procedure,virtual
            end

